option explicit

' global const values
const SHOWFPS = 0
const PORTEMPTY = 0
const PORTNUNCHUK = 1
const PORTCLASSIC = 2
const PORTDIGITAL = 3
const PORTKEYBOARD = 4
const DUP = 35
const DDOWN = 36
const DLEFT = 38
const DRIGHT = 40
const DFIRE = 32
const UFOSPEED = 6
const TANKSPEED = 2
const SHOTSPEED = 4
const BOMBSPEED = 2
const DELAYBETWEENSHOTS = 40
const MAXSHOTS = 20
const MAXUFOS = 10
const MAXBOMBS = 30
const MAXHISCORE = 20
const MAXPLAYERS = 4

' HiScores
dim ATHSName(MAXHISCORE) as string   ' All Time HiScore Name
dim ATHSScore(MAXHISCORE) as integer ' All Time HiScore Score
dim ATHSMark(MAXHISCORE) as integer  ' All Time HiScore Highlight
dim HSName(MAXHISCORE) as string     ' Daily HiScore Name
dim HSScore(MAXHISCORE) as integer   ' Daily HiScore Score
dim HSMark(MAXHISCORE) as integer    ' Daily HiScore Highlight

' global variables
dim PColors(4) as integer = (rgb(white), rgb(yellow), rgb(green), rgb(blue), rgb(brown))
dim CPort(3) as integer              ' Flags: Controllertype in port #1, 2, 3
dim Abort as integer                 ' Flag : Abort current screen?
dim Ende as integer                  ' Flag : Leave game?
dim DoPause as integer               ' Flag : Pause requested by player?
dim CanPause as integer              ' Flag : Pause enabled?
dim Score as integer                 ' actual score
dim Lives as integer                 ' Sum of all lives
dim fh as integer                    ' Font height in pixel
dim fw as integer                    ' Font width in pixel  
dim fc as integer                    ' Frame Counter
dim SSFlag as integer                ' Flag to indicate ScreenShot must be taken
dim MonoColor as integer             ' Flag if all players are white
dim sno as integer                   ' Screenshot number 

' Tanks / Players
dim Player(MAXPLAYERS) as string     ' Player names
dim GoLeft(MAXPLAYERS) as integer    ' Flag : Move tank right?
dim GoRight(MAXPLAYERS) as integer   ' Flag : Move tank left?
dim Fire(MAXPLAYERS) as integer      ' Flag : Fire canon?
dim tscore(MAXPLAYERS) as integer    ' Tank score
dim tx(MAXPLAYERS) as integer        ' Tank x position
dim ty(MAXPLAYERS) as integer        ' Tank y position
dim tl(MAXPLAYERS) as integer        ' Tank lives
dim tc(MAXPLAYERS) as integer        ' Tank colour
dim tp(MAXPLAYERS) as integer        ' Tank controller port number
dim tt(MAXPLAYERS) as integer        ' Tank controller port type (PORTEMPTY if player is inactive)
dim ts(MAXPLAYERS) as integer        ' Tank delay between shots
dim ti(MAXPLAYERS) as integer        ' Tank invulnerability for x ticks
dim tb(MAXPLAYERS) as integer        ' Tank blink if invulnerable
dim tleft(MAXPLAYERS) as integer     ' Tank left movement key if keyboard conbtrol is active
dim tright(MAXPLAYERS) as integer    ' Tank right movement key if keyboard conbtrol is active
dim tfire(MAXPLAYERS) as integer     ' Tank fire movement key if keyboard conbtrol is active

dim grTank(2) as string = ("", "|ooo|", "/ \")         ' Tank "graphics"
dim grTankEmpty(2) as string = ("", "     ", "   ")    ' "Graphics" to clear tank

' UFO
dim grUfo as string = "<=>"          ' UFO "graphics"
dim grUfoEmpty as string = "   "     ' "Graphics" to clear UFO
dim ux(MAXUFOS) as integer           ' UFO x position
dim uy(MAXUFOS) as integer           ' UFO y position
dim uc(MAXUFOS) as integer           ' UFO colour
dim udeltax(MAXUFOS) as integer      ' UFO direction
dim uf(MAXUFOS) as integer           ' Flag : UFO active?
dim ufodelay as integer              ' delay between UFOs

' Shot
dim sf(MAXSHOTS) as integer          ' Tank bullet flag : shot active?
dim sx(MAXSHOTS) as integer          ' Tank bullet x
dim sy(MAXSHOTS) as integer          ' Tank bullet y
dim sp(MAXSHOTS) as integer          ' from which Player the shot was fired

' Bomb
dim bf(MAXBOMBS) as integer          ' UFO bomb flag : bomb active?
dim bx(MAXBOMBS) as integer          ' UFO bomb x
dim by(MAXBOMBS) as integer          ' UFO bomb y
dim bombchance as integer            ' chance to drop a bomb, 1:bombchance

' 640x400, 256 colours
mode 2,8

fh = mm.info(fontheight)
fw = mm.info(fontwidth)

' print to hidden page
page write 1

' initialization 
InitHiScores
InitDigitalJoystick
InitController
Abort = 0
Ende = 0
sno = 0

timer = 0
fc = 0

' clear all pending inputs
ClearInput
ClearFire

do
   ' show hiscores and wait for RETURN or ESC
   ScoreLoop

   if not Ende then
      ' configure players  
      PlayerDefLoop

      if not Abort then
         ' game loop
         GameLoop 
      endif

   endif  

loop until Ende=1

CloseController

page write 0
end

'
' Main game loop
sub GameLoop
   local Key as string

   ResetPlayers
   
   ' game loop
   ClearInput

   Score = 0
   InitRound
   bombchance = 250
   CanPause = 1       

   do
      cls
      colour rgb(cyan)
      text mm.hres / 2, 0, "Tanks vs. UFOs", "C"
      colour rgb(white) 
      line 0, fh, mm.hres-1, fh


      line 0,mm.vres - fh*4, mm.hres-1, mm.vres - fh*4

      ' Show player infos
      ShowPlayerInfos

      ' get user input
      if Lives = 0 then
         text mm.hres / 2, mm.vres / 2, "RETURN or ESC to leave screen", "C"
         Key = inkey$
         if Key = chr$(13) or Key = chr$(27) then
            Abort = 1
         endif
      else
         GetInput
      endif

      ' process input
      HandleInput

      ' show tanks
      DrawTanks

      ' move and test shot
      HandleShots

      ' move and test bomb
      HandleBombs

      ' move or restart UFO
      HandleUFOs

      ' Update status
      ShowStats

      inc fc
      if SHOWFPS then
         colour rgb(brown)
         text mm.hres-1, mm.vres-fh, " FPS : "+str$(int(fc*1000/timer+0.5)), "R"
         colour rgb(white)
      endif

      ' show page
      page copy 1 to 0, B 

      if SSFlag then
         SSFlag = 0
         ScreenShot
      endif

   loop until Abort = 1

   ' wait until fire button is released
   ClearFire

   ' check hiscores
   CheckAllScores   
end sub

'
' Show player info
sub ShowPlayerInfos
   local p as integer
   for p=1 to 4
      if tt(p) <> PORTEMPTY then 
         if MonoColor then
            colour PColors(0)
         else
            colour PColors(p)
         endif
         text (p-1)*160+80, mm.vres - fh*3 - fh/2, Player(p), "C"
         colour rgb(white)
         text (p-1)*160+80, mm.vres - fh*2, "Score " + str$(tscore(p)), "C"
         if tl(p)=3 then
            colour rgb(green)
         else if tl(p)=2 then
            colour rgb(yellow)
         else
            colour rgb(red)
         endif 
         text (p-1)*160+80, mm.vres - fh, "Tanks " + str$(tl(p)), "C"
      endif
   next
   colour rgb(white)
end sub

'
' Initialize player values
sub ResetPlayers
   local p as integer
   Lives = 0
   for p=1 to MAXPLAYERS
      GoLeft(p) = 0
      GoRight(p) = 0
      Fire(p) = 0
      tscore(p) = 0 
      tx(p) = mm.hres/2
      ty(p) = mm.vres - fh*5
      tscore(p) = 0
      if tt(p) <> PORTEMPTY then
         tl(p) = 3
      else
         tl(p) = 0
      endif
      Lives = Lives + tl(p)
      ts(p) = 0      
      ti(p) = 0
      tb(p) = 0
   next
end sub

'
' Wait until fire buttons released
sub ClearFire
   local AnyFire as integer
   local p as integer
   
   do
      GetInput
      for p=1 to MAXPLAYERS
         AnyFire = AnyFire + Fire(p)
      next   
   loop until AnyFire = 0
end sub

'
' Wait until no keys are pressed
sub ClearInput
   do
   loop until inkey$="" and keydown(0)=0
end sub

'
' Show Scores, enter name for HiScore
sub ScoreLoop
   local Info as string
   local Key as string
   local CInfo as string
   local p as integer
   local NewGame as integer = 0
   
   for p=1 to 3
      select case CPort(p)
         case PORTNUNCHUK
            CInfo = CInfo + "  port #"+str$(p)+" = Nunchuk  "
         case PORTCLASSIC
            CInfo = CInfo + "  port #"+str$(p)+" = Classic  "
      end select
   next
   
   CanPause = 0

   ' wait until no keys are pressed
   ClearInput
   
   ' intro loop
   do
      cls
      text mm.hres / 2, 0, "Tanks vs. UFOs", "C"
      line 0, fh, mm.hres-1, fh

      colour rgb(255, 64, 64)
      text mm.hres / 2, fh*2, "GAME OVER", "C"
     
      colour rgb(64, 64, 255)
      Info = "Group score: "
      Info = Info + str$(Score)
      text mm.hres / 2, fh*4, Info, "C"

      colour rgb(white)

      line 0,mm.vres - fh*4, mm.hres-1, mm.vres - fh*4

      colour rgb(64, 64, 255)
      text mm.hres/2, mm.vres - fh*3, "Start game RETURN or leave game with ESC key", "C"

      colour rgb(64, 255, 64)
      text mm.hres/2, mm.vres - fh, CInfo, "C"
      colour rgb(gray)
      text mm.hres/2, mm.vres - fh*5-fh/2, "(Hint: Higher and faster UFOs give more points!)", "C"
      colour rgb(white)


      ShowHiScores fh*5.5

      ' check for RETURN or ESC
      Key = inkey$   
      if key=chr$(27) then
         Ende = 1
      else if key=chr$(13) then
         NewGame = 1 
      else if Key=chr$(157) then
         SSFlag=1
      endif     

      inc fc
      if SHOWFPS then
         colour rgb(brown)
         text mm.hres-1, mm.vres-fh, " FPS : "+str$(int(fc*1000/timer+0.5)), "R"
         colour rgb(white)
      endif

      ' show page
      page copy 1 to 0, B 

      if SSFlag then
         SSFlag = 0
         ScreenShot
      endif

   loop until NewGame=1 or Ende=1

   ' wait until fire buttons and all keys are released
   ClearFire
   ClearInput

end sub

'
' Return human readable description for controller type
function GetControllerTypeName(p as integer) as string
   local ControllerName as string
   select case p
      case PORTEMPTY 
         ControllerName = "<unused>"
      case PORTNUNCHUK
         ControllerName = "Nunchuk"
      case PORTCLASSIC
         ControllerName = "Classic"
      case PORTDIGITAL
         ControllerName = "Digital"
      case PORTKEYBOARD 
         ControllerName = "Keyboard" 
   end select

   GetControllerTypeName = ControllerName
end function

'
' Show key in readable form
function ShowKey(Key as integer) as string
   local Result as string = ""
   if Key>127 then
      select case Key
         case 128
            Result = "up"
         case 129
            Result = "down"
         case 130
            Result = "left"
         case 131
            Result = "right"
         case else
            Result = ""
      end select
   else
      if Key=32 then
         Result = "spc"
      else
         Result = chr$(Key)
      endif 
   endif
   ShowKey = Result
end function

'
' Initialize Player controls and colours
sub PlayerDefLoop
   local i as integer
   local y as integer
   local pl as integer
   local EnterName as integer
   local BlinkOn as integer
   local BlinkDelay as integer
   local Key as string
   local NewGame as integer
   local DefineFire as integer
   local DefineLeft as integer
   local DefineRight as integer
   local SKey as string

   ' wait until no keys are pressed
   ClearInput

   Abort = 0
   DefineFire = 0
   DefineLeft = 0
   DefineRight = 0
   EnterName = 0
   
   ' intro loop
   do
      cls
      colour rgb(white)

      text mm.hres / 2, 0, "Tanks vs. UFOs", "C"
      line 0, fh, mm.hres-1, fh
      line 0,mm.vres - fh*4, mm.hres-1, mm.vres - fh*4

      colour rgb(brown)
      text mm.hres / 2, fh*3, "Configure players", "C"

      colour rgb(64, 64, 255)
      text mm.hres/2, mm.vres - fh*3.5, "Press 1 to 4 to activate and configure player, C for colours", "C"
      text mm.hres/2, mm.vres - fh*2.5, "ESC to return to startscreen, RETURN to start game", "C"

      text fw*2, fh*7, "Player"
      text fw*10, fh*7, "Controller"
      text fw*25, fh*7, "Fire Left Right"
      text fw*50, fh*7, "Name"

      for i=1 to 4
         y = (fh*(7.5+i*2))
         if i=pl then
            colour rgb(yellow)     
         else if tt(i)=PORTEMPTY then
            colour rgb(gray)     
         else
            colour rgb(white)     
         endif               
         text fw*2, y, str$(i)
         text fw*10, y, GetControllerTypeName(tt(i))+choice(tp(i)>0, " #"+str$(tp(i)),"")
         if tt(i)=PORTKEYBOARD then
            text fw*27, y, ShowKey(tfire(i)), "C"
            text fw*32, y, ShowKey(tleft(i)), "C"
            text fw*37, y, ShowKey(tright(i)), "C"
         endif
         text fw*50, y, Player(i)+choice(i=pl and BlinkOn, "_", "")

         box fw*4, y, fw*5, fh, ,, choice(MonoColor, PColors(0), PColors(i))
      next 

      ' check for input
      Key=Inkey$

      if pl>0 and Key=chr$(27) then
         tt(pl) = PORTEMPTY
         tp(pl) = 0
         tfire(pl) = 0
         tleft(pl) = 0
         tright(pl) = 0 
         pl = 0
         DefineFire = 0
         DefineLeft = 0
         DefineRight = 0
         EnterName = 0
         Key = ""
      endif

      if pl then
         if DefineFire then
            ' define controller for player
            text mm.hres/2, fh*20, "Press button or key to define controller and fire button", "C"

            if Key <> "" then
               if not KeyInUse(asc(Key), pl) then
                  tfire(pl) = Asc(key)
                  tt(pl) = PORTKEYBOARD
                  DefineFire = 0
                  DefineLeft = 1
               endif
            else
               ' Check controller
               tp(pl) = GetController()
               if tp(pl) <> 0 then
                  if not ControllerInUse(tp(pl), pl) then
                     if tp(pl)=4 then
                        tt(pl) = PORTDIGITAL
                     else
                        tt(pl) = CPort(tp(pl))
                     endif
                     DefineFire = 0
                     EnterName = 1
                  endif
               endif
            endif
         else if DefineLeft then
            ' define left key
            text mm.hres/2, fh*20, "Press key to define left", "C"

            if Key <> "" then
               if not KeyInUse(asc(Key), pl) then
                  tleft(pl) = Asc(key)
                  DefineLeft = 0
                  DefineRight = 1
               endif
            endif            
         else if DefineRight then
            ' define right key
            text mm.hres/2, fh*20, "Press key to define right", "C"

            if Key <> "" then
               if not KeyInUse(asc(Key), pl) then
                  tright(pl) = Asc(key)
                  DefineRight = 0
                  EnterName = 1
               endif
            endif            
         else if EnterName then
            ' enter name for Player
            text mm.hres/2, fh*20, "Enter name, end with RETURN", "C"

            BlinkDelay = BlinkDelay -1 
            if BlinkDelay <=0 then
               BlinkOn = 1-BlinkOn
               BlinkDelay = 25
            endif
            if key<>"" then
               if Key=chr$(13) then
                  ' Input finished
                  EnterName = 0
                  pl = 0
               else if Key=chr$(8) then
                  if Player(pl)<>"" then
                     Player(pl) = Left$(Player(pl), len(Player(pl))-1)
                  endif
               else if asc(Key)>=32 and asc(Key)<128 then
                  if len(Player(pl))<10 then
                     Player(pl) = Player(pl) + Key
                  endif
               endif
            
               ' finished and an AllTime Hiscore? 
               if not EnterName then
                  BlinkOn = 0
               endif
            endif
         endif
      else
         ' check for 1-4 or return
         if Key="1" then
            pl = 1
         else if Key="2" then
            pl = 2
         else if Key="3" then
            pl = 3
         else if Key="4" then
            pl = 4
         else if Key="c" or Key="C" then
            MonoColor = 1-MonoColor
         else if Key=chr$(13) then
            NewGame = 1
         else if Key=chr$(27) then
            Abort = 1
         else if Key=chr$(157) then
            SSFlag = 1
         endif
         if pl then
            DefineFire = 1
         endif
      endif
      
      inc fc
      if SHOWFPS then
         colour rgb(brown)
         text mm.hres-1, mm.vres-fh, " FPS : "+str$(int(fc*1000/timer+0.5)), "R"
         colour rgb(white)
      endif

      ' show page
      page copy 1 to 0, B 

      if SSFlag then
         SSFlag = 0
         ScreenShot
      endif

   loop until NewGame=1 or Abort=1

   ' wait until fire button and keys are release
   ClearFire
   ClearInput

end sub

'
' check if controller (port) is already in use by another player
function ControllerInUse(p as integer, t as integer) as integer
   local i as integer = 0
   local Result as integer = 0

   for i=1 to MAXPLAYERS
      if i<>t then
         if tp(i) = p then
            Result = 1
            exit for
         endif
      endif
   next
   ControllerInUse = Result
end function

'
' check if key is already in use
function KeyInUse (Key as integer, t as integer) as integer
   local i as integer = 0
   local Result as integer = 0

   for i=1 to MAXPLAYERS
      if tleft(i) = Key then
         Result = 1
         exit for
      endif
      if tright(i) = Key then
         Result = 1
         exit for
      endif
      if tfire(i) = Key then
         Result = 1
         exit for
      endif
   next
   KeyInUse = Result
end function

'
' Pause loop
sub PauseLoop
   local Key as string

   ' wait until no keys are pressed
   ClearInput
   
   ' intro loop
   do
      cls
      text mm.hres / 2, 0, "Tanks vs. UFOs", "C"
      line 0, fh, mm.hres-1, fh

      colour rgb(yellow)
      text mm.hres / 2, fh*2, "PAUSE", "C"
      colour rgb(white)
      text mm.hres/2, mm.vres - fh*2, "ESC to quit round, any other key to continue", "C"
      
      Key=inkey$
      if Key<>"" then
         DoPause = 0 
         if Key=chr$(27) then
            Abort = 1
         endif
      endif

      ' show page
      page copy 1 to 0, B 

      inc fc
      text mm.hres-1, mm.vres-fh, " "+str$(int(fc*1000/timer)), "R"

   loop until DoPause = 0

   ClearInput   
end sub

'
' Initialize HiSore Tables
sub InitHiScores
   local i as integer

   for i=1 to MAXHISCORE
      ATHSName(i) = "----------"
      ATHSScore(i) = 0
      ATHSMark(i) = 0
      HSName(i) = "----------"
      HSScore(i) = 0
      HSMark(i) = 0
   next
   LoadATHiScores
end sub

'
' Save AllTime-HiScores to file
sub SaveATHiScores
   local i as integer
   local s as string

   open "TsvUs.hsc" for output as #1
   for i=1 to MAXHISCORE
      print #1, ATHSName(i)
      print #1, ATHSScore(i) 
   next
   close #1
end sub

'
' Show Hi-Scores
sub ShowHiScores y as integer
   local i as integer
   local x1 as integer = (320-24*fw)/2
   local x2 as integer = x1+320

   colour rgb(green)
   text (320-17*fw)/2, y, "All time HiScores"
   colour rgb(yellow)
   text 320+(320-15*fw)/2, y, "Todays HiScores"
   colour rgb(255,255,255)

   y=y+fh/2

   for i=1 TO MAXHISCORE
      ' all time hiscores
      if ATHSMark(i) then
         colour rgb(green)
      else
         colour rgb(white)
      endif
      text x1-fw*4, y+i*fh, right$("  "+str$(i)+".", 3)
      text x1, y+i*fh, ATHSName(i)
      text x1+fw*12, y+i*fh, right$("............"+str$(ATHSScore(i)), 12)

      ' daily hiscores
      if HSMark(i) then
         colour rgb(yellow)
      else
         colour rgb(white)
      endif
      text x2-fw*4, y+i*fh, right$("  "+str$(i)+".", 3)
      text x2, y+i*fh, HSName(i)
      text x2+fw*12, y+i*fh, right$("............"+str$(HSScore(i)), 12)
   next

end sub

'
' Load AllTime-HiScores from file
sub LoadATHIScores
   local i as integer
   local s as string

   on error skip
   open "TsvUs.hsc" for input as #1

   ' file not found?
   if mm.errno<>0 then
      exit sub
   endif

   for i=1 to MAXHISCORE
      line input #1, ATHSName(i)
      line input #1, s
      ATHSScore(i) = val(s)
      ATHSMark(i) = 0
   next

   close #1
   
end sub

'
' check all player scores against Hiscores
sub CheckAllScores
   local p as integer
   local f as integer = 0
   for p=1 to MAXHISCORE
      ATHSMark(p) = 0
      HSMark(p) = 0
   next

   for p=1 to MAXPLAYERS
      if tt(p) <> PORTEMPTY then
         f = f + Check4HiScore(p, tscore(p))
      endif
   next

   if f>0 then
      SaveATHiScores
   endif
end sub

'
' Check for HiScore - AllTime and Daily
function Check4HiScore (p as integer, sc as integer) as integer
   local i as integer
   local ATEntry as integer = 0
   local HSEntry as integer = 0
   
   for i=1 to MAXHISCORE
      if ATEntry=0 then
         if ATHSScore(i)<sc then
            ATEntry = i
         endif  
      endif
      if HSEntry=0 then
         if HSScore(i)<sc then
            HSEntry = i
         endif  
      endif
   next

   if (ATEntry>0) and (ATEntry<MAXHISCORE) then
      for i=MAXHISCORE to ATEntry+1 STEP -1
         ATHSName(i) = ATHSName(i-1)
         ATHSSCore(i) = ATHSSCore(i-1)
         ATHSMark(i) = ATHSMark(i-1)
      next       
      ATHSName(ATEntry) = Player(p)
      ATHSScore(ATEntry) = tscore(p)
      ATHSMark(ATEntry) = 1
   endif

   if (HSEntry>0) and (HSEntry<MAXHISCORE) then
      for i=MAXHISCORE to HSEntry+1 STEP -1
         HSName(i) = HSName(i-1)
         HSSCore(i) = HSSCore(i-1)
         HSMark(i) = HSMark(i-1)
      next       
      HSMark(HSEntry) = 1
      HSName(HSEntry) = Player(p)
      HSScore(HSEntry) = tscore(p)
   endif

   Check4HiScore = ATEntry>0
end function

'
' Initialize UFO, shot and bomb flags
sub InitRound
   local i as integer
   for i=1 to MAXBOMBS
      bf(i) = 0
   next
   for i=1 to MAXSHOTS
      sf(i) = 0
   next
   for i=1 to MAXUFOS
      uf(i) = 0
   next

   DrawTanks

end sub

'
' show status values 
sub ShowStats
   local i as integer

   if Lives>=3 then
      colour rgb(green)
   else if Lives = 2 then
      colour rgb(yellow)
   else
      colour rgb(red)
   endif
   text 0, 0, "All tanks "+str$(Lives)+" ", "L"
   if Score>ATHSScore(MAXHISCORE) then
      colour rgb(green)
   else if Score>HSScore(MAXHISCORE) then
      colour rgb(yellow)
   else
      colour rgb(white)
   endif
   text mm.hres-1, 0, "Group score "+str$(Score), "R"
   colour rgb(white)
end sub

'
' handle Player input
sub HandleInput
   local i as integer
   local t as integer

   if DoPause then
      PauseLoop
   endif

   for t=1 to MAXPLAYERS
      ' move tank left?
      if GoLeft(t)=1 then
         MoveTank t, -TANKSPEED
         GoLeft(t) = 0
      endif

      ' move tank right?
      if GoRight(t)=1 then
         MoveTank t, TANKSPEED
         GoRight(t) = 0
      endif

      ' fire a bullet? 
      if ts(t)>0 then
         ts(t) = ts(t)-1
      else
         if Fire(t) then
            for i=1 to MAXSHOTS
               if sf(i) = 0 then
                  sx(i) = tx(t)
                  sy(i) = ty(t) - fh
                  sp(i) = t
                  sf(i) = 1
                  ts(t) = DELAYBETWEENSHOTS
                  exit for
               endif
            next
         endif
      endif
      Fire(t) = 0
   next
end sub

'
' handle tank shots
sub HandleShots
   local s as integer
   local u as integer

   colour rgb(yellow)
   for s=1 to MAXSHOTS
      if sf(s) = 1 then

         sy(s) = sy(s) - SHOTSPEED

         ' check against UFO
         for u=1 to MAXUFOS
            if CheckShotAgainstUfo (s, u) then
               exit for
            endif
         next
  
         if sy(s) <= fh*2 then
            sf(s) = 0
         endif
            
         if sf(s)=1 then
            text sx(s), sy(s), "^", "C"
         endif

      endif
   next
colour rgb(white)
end sub

'
' clear all shots
sub ClearShots
   local s as integer
   for s=1 to MAXSHOTS
      if sf(s) then
         sf(s) = 0
      endif
   next
end sub

'
' Check if shot #s hits ufo #u
function CheckShotAgainstUfo (s as integer, u as integer) as integer
   local result as integer =  0 
   local sc as integer

   if uf(u) then
      if CheckCollision(sx(s), sy(s), sx(s)+fw, sy(s)+fh, ux(u)-1.5*fw, uy(u), ux(u)+1.5*fw, uy(u)+fh) then
         ' shot meets UFO :-)
         sf(s) = 0
         uf(u) = 0

         ' calculate score depending on height and speed of UFO 
         sc = (((mm.vres-fh*5)-uy(u))\10) * abs(udeltax(u))
         Score = Score + sc
         tscore(sp(s)) = tscore(sp(s)) + sc
         result = 1
      endif
   endif
   CheckShotAgainstUfo = result
end function

'
' check rectangle overlapping
function CheckCollision (sx1 as integer, sy1 as integer, ex1 as integer, ey1 as integer, sx2 as integer, sy2 as integer, ex2 as integer, ey2 as integer) as integer
   local result as integer = 0

   if ex1 >= sx2 then
      if sx1 <= ex2 then
         if ey1 >= sy2 then
            if sy1 <= ey2 then
               ' collision
               result = 1 
            endif
         endif
      endif        
   endif        
   CheckCollision = result      
end function

'
' handle UFO bombs
sub HandleBombs
   local b as integer
   local r as integer
   local p as integer
   local bhit as integer
      
   for b=1 to MAXBOMBS

      if Lives = 0 then
         bf(b) = 0
      endif

      if bf(b) = 1 then
         by(b) = by(b) + BOMBSPEED

         bhit = 0
         ' check against Tanks
         for p=1 to MAXPLAYERS
            if tl(p)>0 then
               if CheckCollision(bx(b)-fw/2, by(b), bx(b)+fw/2, by(b)+fh, tx(p)-2.5*fw, ty(p), tx(p)+2.5*fw, ty(p)+2*fh) then
                  bf(b) = 0

                  ' Tank not invulnerable?
                  if ti(p)=0 then     
                     ' reduce player lives
                     tl(p) = tl(p)-1
                     ' make player invulnerable for  second
                     ti(p) = 75 
                     ' player can't shoot when invulnerable
                     ts(p) = 75

                     tb(p) = 0
                   
                     Lives = Lives - 1
                     if Lives = 0 then
                        CanPause = 0
                     endif
                  endif

                  bhit=1      

               endif
            endif      
         next    

         if bhit then
            bf(b) = 0
         else
            if by(b) >= mm.vres - fh*5 then
               bf(b) = 0
            endif
         endif            

         if bf(b)=1 then 
            r = (by(b)/400)*255
            colour rgb(255, 255-r, 255-r)
            text bx(b), by(b), "o", "C"
         endif

      endif
   next
   colour rgb(white)

end sub

'
' handle all UFOs
sub HandleUFOs
   local u as integer
   local cnt as integer = 0

   for u=1 to MAXUFOS
      HandleUFO u
      if uf(u) then
         cnt = cnt + 1
      endif
   next

   ' all Tanks defeated, all UFOs left screen -> Game Over
   if Lives=0 and cnt=0 then
      ClearShots
   endif
end sub

'
' handle UFO
sub HandleUFO u as integer
   local i as integer

   if uf(u) = 1 then
      if Lives=0 then
         if udeltax(u)<0 then
            udeltax(u)=udeltax(u)-1
         else
            udeltax(u)=udeltax(u)+1
         endif 
      endif
      ux(u) = ux(u) + udeltax(u)
      if ux(u)>-12 and ux(u)<(mm.hres+12) then
         DrawUFO u
         if Lives>0 and int(rnd()*BOMBCHANCE) = 0 then
            for i=1 to MAXBOMBS
               if bf(i) = 0 then
                  bf(i) = 1
                  bx(i) = ux(u)
                  by(i) = uy(u)+fh
                  exit for
               endif
            next
         endif
      else
         uf(u) = 0
         if Lives>0 and bombchance > 10 then
            bombchance = bombchance - 1
         endif
      endif
   else
      if Lives>0 and ufodelay=0 then
         uf(u) = 1
         uy(u) = fh*2 + rnd()*(mm.vres-fh*10)
         uc(u) = rgb(64+rnd()*191, 64+rnd()*191, 64+rnd()*191)
         udeltax(u) = rnd()*UFOSPEED-(UFOSPEED/2)
         if udeltax(u)=0 then
            udeltax(u)=1
         endif
         if udeltax(u)>0 then
            ux(u)=-12
         else
            ux(u)=mm.hres+12
         endif
         ufodelay = 40
      else
         if ufodelay>0 then
            ufodelay=ufodelay-1
         endif
      endif
   endif
end sub

'
' draw UFO
sub DrawUFO u as integer
   colour uc(u)
   text ux(u), uy(u), grUfo, "C"
   colour rgb(white) 
end sub

'
' move tank to left or right
sub MoveTank p as integer, DeltaX as integer
   ' check if new position is in bounds
   if tx(p)+DeltaX<24 then
      exit sub 
   endif
   if tx(p)+DeltaX>mm.hres-24 then
      exit sub 
   endif

   tx(p) = tx(p) + DeltaX
end sub


'
' draw all tanks
sub DrawTanks
   local p as integer
   for p=1 to MAXPLAYERS
      DrawTank p
   next   
end sub

'
' draw tank to screen
sub DrawTank t as integer
   if tl(t)>0 then

      ' let invulnerable tanks flicker
      if ti(t)>0 then
         ti(t)=ti(t)-1
         if ti(t) mod 15 = 0 then
            tb(t) = 1 - tb(t)
         endif
         if tb(t) then
            exit sub
         endif
      endif

      if MonoColor then
         colour PColors(0)
      else
         colour PColors(t)
      endif

      text tx(t), ty(t), grTank(1), "C", , , , -1
      text tx(t), ty(t)-fh, grTank(2), "C", , , , -1

      if ts(t)=0 then
         text tx(t), ty(t)-fh, "^", "C", , , , -1
      endif

      colour rgb(white)

   endif
end sub

'
' check for user input
sub GetInput
   local i as integer
   local jx as integer
   local p as integer
   
   ' reset all flags
   for p=1 to MAXPLAYERS
      GoLeft(i) = 0
      GoRight(i) = 0
      Fire(i) = 0
   next
   
   ' check all pressed keys
   local KeyCount as integer = keydown(0)
   if keycount>0 then
      for i=1 to KeyCount
         if KeyDown(i)=157 then
            SSFlag = 1    
         else if KeyDown(i)=27 then
            if CanPause then
               DoPause = 1
            else
               Abort = 1
            endif
         else
            ' check if any player uses this key as input    
            for p=1 to MAXPLAYERS
               if tl(p)>0 then
                  if tt(p) = PORTKEYBOARD then
                     if KeyDown(i)=tleft(p) then
                        GoLeft(p) = 1
                     else if KeyDown(i)=tright(p) then          
                        GoRight(p) = 1
                     else if KeyDown(i)=tfire(p) then          
                        Fire(p) = 1
                     endif
                  endif
               endif 
            next       
         endif
      next
   endif  

   ' check controllers
   for p=1 to MAXPLAYERS
      if tl(p)>0 then
         select case tt(p)
            case PORTNUNCHUK
               jx = nunchuk(jx, tp(p))
               if jx < 64 then
                  GoLeft(p) = 1
               endif
               if jx > 192 then
                  GoRight(p) = 1
               endif
               if nunchuk(Z, tp(p)) then
                  Fire(p) = 1
               endif
            case PORTCLASSIC
               jx = classic(lx, tp(p))
               if jx < 64 then
                  GoLeft(p) = 1
               endif
               if jx > 192 then
                  GoRight(p) = 1
               endif
               jx = classic(rx, tp(p))
               if jx < 64 then
                  GoLeft(p) = 1
               endif
               if jx > 192 then
                  GoRight(p) = 1
               endif
               ' Button and digital joystick test
               jx = classic(B, tp(p))
               if jx <> 0 then
                  if jx and 64 then
                     GoRight(p) = 1
                  endif
                  if jx and 256 then
                     GoLeft(p) = 1
                  endif
                  if jx and &b0011111000011111 then
                     Fire(p) = 1
                  endif 
               endif
            case PORTDIGITAL
               ' check digital joystick
               ' active pins read as value 0!
               if pin(DLEFT) = 0 then
                  GoLeft(p) = 1
               end if
               if pin(DRIGHT) = 0 then
                  GoRight(p) = 1
               end if
               if pin(DFIRE) = 0 then 
                  Fire(p) = 1
               endif
         end select         
      endif
   next
   
end sub

'
' test on which controller a button is pressed
function GetController() as integer
   local Result as integer = PORTEMPTY
   local p as integer
   local jx as integer

   if pin(DFIRE) = 0 then 
      Result = 4
   else
      for p=1 to 3
         select case CPort(p)
            case PORTCLASSIC
               jx = classic(B, p)
               if jx and &b0011111000011111 then
                  Result = p
               endif 
            case PORTNUNCHUK
               if nunchuk(Z, p) then
                  Result = p
               endif
         end select  
      next
   endif
     
   GetController = Result
end function

'
' Initialize Atari-style joystick
sub InitDigitalJoystick
   setpin DUP, din, pullup
   setpin DDOWN, din, pullup
   setpin DLEFT, din, pullup
   setpin DRIGHT, din, pullup
   setpin DFIRE, din, pullup
end sub

'
' Search for controllers on port #1 to #3
sub InitController
   local p as integer
   for p=1 to 3
      CPort(p) = PORTEMPTY
      ' first check for nunchuk - this works for classic controller, too! 
      on error skip
      controller nunchuk open p
      if mm.errno = 0 then
         ' now check if we really have a nunchuk
         ' if both center values are 255 it's not a Nunchuk but a classic controller
         if NUNCHUK(JXC, p)=255 and NUNCHUK(JYC, p)=255 then
            controller nunchuk close p
            on error skip
            controller classic open p
            if mm.errno = 0 then
               CPort(p)=PORTCLASSIC     
            endif
         else       
            CPort(p)=PORTNUNCHUK    
         endif     
      endif  
   next  
end sub

'
' close all controller ports
sub CloseController
   local p as integer
   for p=1 to 3
      select case CPort(p)
         case PORTNUNCHUK
            controller nunchuk close p
         case PORTCLASSIC
            controller classic close p
      end select
   next   
end sub

'
' Save screen as bitmap
sub ScreenShot
   sno = sno+1
   LogEntry str$(sno)
   save image "tvu_"+right$("000"+str$(sno), 3)+".bmp"   
end sub

'
' Debug helper :-)
sub LogEntry Info as string
   open "tvu.txt" for append as #1
   print #1, info
   close #1
end sub
